import { jsx as i } from "react/jsx-runtime";
import { useState as U, useMemo as g, useCallback as w, useEffect as h } from "react";
import { useAuthedUser as G, useApiCatalog as $, useAxiosGet as p, useAxiosMutate as v, getSanitizedName as I, PageLoading as x, TableContainer as L } from "./index.modern.js";
import { useNavigate as S } from "react-router";
import { NavigateExternalInlineIcon as k } from "@fluentui/react-icons";
import { useTranslation as Y } from "react-i18next";
const J = (V) => {
  const [t, P] = U(null), s = G(), A = S(), { t: o } = Y(), { data: m } = $(t), [{ data: d, loading: C, error: E }] = p(
    process.env.REACT_APP_INTEGRATION_API_BASE,
    `tenantProductApiCatalogBase/tenant/${s == null ? void 0 : s.currentTenantId}/product/${process.env.REACT_APP_UNITY_PRODUCT_ID}`,
    {},
    !s,
    !1
  ), [
    {
      data: a,
      loading: N,
      error: b
    }
  ] = p(
    process.env.REACT_APP_INTEGRATION_API_BASE,
    `apicatalog/${t}/promotedConfigEntity/product/${process.env.REACT_APP_UNITY_PRODUCT_ID}`,
    {},
    !t,
    !1
  ), [
    {
      data: r,
      loading: R,
      error: y
    },
    f
  ] = v(
    process.env.REACT_APP_INTEGRATION_API_BASE,
    `apimethod/executeQueryWithParameters/${a == null ? void 0 : a.apiMethodId}`,
    {
      method: "post"
    }
  ), [{ data: l, loading: M, error: B }] = p(
    process.env.REACT_APP_INTEGRATION_API_BASE,
    `apicatalog/${t}/promotedMethodEntities?productId=${process.env.REACT_APP_UNITY_PRODUCT_ID}`,
    {},
    !t,
    !1
  ), D = g(() => {
    if (!l || !r)
      return [];
    let e = [];
    if (Array.isArray(r))
      e = r;
    else
      for (const [n, c] of Object.entries(r))
        e.push(`${n}`);
    return e.reduce((n, c) => {
      const _ = l.find(
        (u) => u.entityName === I(c)
      );
      if (_)
        n.push(_);
      else {
        const u = {
          entityName: c,
          productId: process.env.REACT_APP_UNITY_PRODUCT_ID,
          unityBaseGetAllMethod: null,
          unityBaseGetMethod: null,
          unityBaseCreateMethod: null,
          unityBaseUpdateMethod: null,
          unityBaseDeleteMethod: null
        };
        n.push(u);
      }
      return n;
    }, []);
  }, [l, r]), T = w(
    (e) => {
      A("/crudbrowser", {
        state: {
          entityName: I(e == null ? void 0 : e.entityName),
          apiCatalogId: t
        }
      });
    },
    [A, t]
  ), O = g(
    () => [
      {
        id: 1,
        // Must be unique
        title: o("View"),
        getTitle: (e) => e != null && e.unityBaseGetAllMethod ? o("View") : o("View Method Not Accessible"),
        icon: k,
        onClick: T,
        disabled: !1,
        checkDisabled: (e) => !(e != null && e.unityBaseGetAllMethod)
      }
    ],
    [T, o]
  );
  return h(() => {
    d && P(d.apiCatalogId);
  }, [d]), h(() => {
    a != null && a.apiMethodId && f({ data: {} });
  }, [f, a]), C || N || R ? /* @__PURE__ */ i(x, {}) : E ? /* @__PURE__ */ i("div", { children: o("There is no Api Catalog associated with your tenant and product") }) : b ? /* @__PURE__ */ i("div", { children: o(
    "Please promote your get configuration tables method before proceeding"
  ) }) : y ? /* @__PURE__ */ i("div", { children: o("No configuration tables could be found") }) : /* @__PURE__ */ i(
    L,
    {
      actionList: O,
      rowData: D,
      loading: M,
      catalog: m,
      error: B
    }
  );
};
export {
  J as default
};
